diff --git a/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/TraktAPI.cs b/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/TraktAPI.cs
index 542fcce..be4cd5d 100644
--- a/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/TraktAPI.cs
+++ b/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/TraktAPI.cs
@@ -75,1007 +32,899 @@ namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt
     seven,
     eight,
     nine,
-    ten,
-    love, //deprecated - ten
-    hate  //deprecated - one
-  }
-
-  /// <summary>
-  /// Trakt Connection States
-  /// </summary>
-  public enum ConnectionState
-  {
-    Connected,
-    Connecting,
-    Disconnected,
-    Invalid,
-    Pending
+    ten
   }
 
-  /// <summary>
-  /// Privacy Level for Lists
-  /// </summary>
-  public enum ListPrivacyLevel
+  public static class TraktAPI
   {
-    Public,
-    Private,
-    Friends
-  }
+    #region Web Events
 
-  /// <summary>
-  /// Defaults to all, but you can instead send a comma delimited list of actions. 
-  /// For example, /all or /watching,scrobble,seen or /rating.
-  /// </summary>
-  public enum ActivityAction
-  {
-    all,
-    watching,
-    scrobble,
-    checkin,
-    seen,
-    collection,
-    rating,
-    watchlist,
-    review,
-    shout,
-    created,
-    item_added
-  }
+    // these events can be used to log data sent / received from trakt
+    public delegate void OnDataSendDelegate(string url, string postData);
 
-  /// <summary>
-  /// Defaults to all, but you can instead send a comma delimited list of types.
-  /// For example, /all or /movie,show or /list.
-  /// </summary>
-  public enum ActivityType
-  {
-    all,
-    episode,
-    show,
-    movie,
-    list
-  }
+    public delegate void OnDataReceivedDelegate(string response, HttpWebResponse webResponse);
 
-  [Flags]
-  public enum SearchType
-  {
-    none = 0,
-    movies = 1,
-    shows = 2,
-    episodes = 4,
-    people = 8,
-    users = 16
-  }
-  // ReSharper restore InconsistentNaming
+    public delegate void OnDataErrorDelegate(string error);
 
-  #endregion
+    public delegate void OnLatencyDelegate(double totalElapsedTime, HttpWebResponse webResponse, int dataSent, int dataReceived);
 
-  /// <summary>
-  /// Object that communicates with the Trakt API
-  /// </summary>
-  public class TraktAPI
-  {
-    #region Transmit Events
-    // these events can be used to log data sent / received from trakt
-    internal delegate void OnDataSendDelegate(string url, string postData);
-    internal delegate void OnDataReceivedDelegate(string response);
-    internal delegate void OnDataErrorDelegate(string error);
+    public static event OnDataSendDelegate OnDataSend;
+    public static event OnDataReceivedDelegate OnDataReceived;
+    public static event OnDataErrorDelegate OnDataError;
+    public static event OnLatencyDelegate OnLatency;
 
-    internal static event OnDataSendDelegate OnDataSend;
-    internal static event OnDataReceivedDelegate OnDataReceived;
-    internal static event OnDataErrorDelegate OnDataError;
     #endregion
 
     #region Settings
 
+    // these settings should be set before sending data to trakt
+    // exception being the UserToken which is set after logon
+
+    public static string ApplicationId { get; set; }
     public static string Username { get; set; }
     public static string Password { get; set; }
+    public static string UserToken { get; set; }
     public static string UserAgent { get; set; }
+    public static bool UseSSL { get; set; }
 
     #endregion
 
-    #region Scrobbling
+    #region Trakt Methods
+
+    #region Authentication
 
     /// <summary>
-    /// Sends Scrobble data to Trakt
+    /// Login to trakt and to request a user token for all subsequent requests
     /// </summary>
-    /// <param name="scrobbleData">The Data to send</param>
-    /// <param name="status">The mode to send it as</param>
-    /// <returns>The response from Trakt</returns>
-    public static TraktResponse ScrobbleMovieState(TraktMovieScrobble scrobbleData, TraktScrobbleStates status)
+    /// <returns></returns>
+    public static TraktUserToken Login(string loginData = null)
     {
-      //If we are cancelling a scrobble we don't need data
-      if (status != TraktScrobbleStates.cancelwatching)
-      {
-        // check that we have everything we need
-        // server can accept title if movie id is not supplied
-        if (scrobbleData == null)
-        {
-          TraktResponse error = new TraktResponse
-          {
-            Error = "Not enough information to send to server",
-            Status = "failure"
-          };
-          return error;
-        }
-      }
+      // clear User Token if set
+      UserToken = null;
 
-      // serialize Scrobble object to JSON and send to server
-      string response = Transmit(string.Format(TraktURIs.ScrobbleMovie, status), scrobbleData.ToJSON());
-
-      // return success or failure
-      return response.FromJSON<TraktResponse>();
+      var response = PostToTrakt(TraktURIs.Login, loginData ?? GetUserLogin(), false);
+      return response.FromJSON<TraktUserToken>();
     }
 
     /// <summary>
-    /// Sends Scrobble data to Trakt
-    /// </summary>
-    /// <param name="scrobbleData">The Data to send</param>
-    /// <param name="status">The mode to send it as</param>
-    /// <returns>The response from Trakt</returns>
-    public static TraktResponse ScrobbleEpisodeState(TraktEpisodeScrobble scrobbleData, TraktScrobbleStates status)
+    /// Gets a User Login object
+    /// </summary>       
+    /// <returns>The User Login json string</returns>
+    private static string GetUserLogin()
     {
-      // check that we have everything we need
-      // server can accept title if movie id is not supplied
-      if (status != TraktScrobbleStates.cancelwatching)
-      {
-        if (scrobbleData == null)
-        {
-          TraktResponse error = new TraktResponse
-          {
-            Error = "Not enough information to send to server",
-            Status = "failure"
-          };
-          return error;
-        }
-      }
-
-      // serialize Scrobble object to JSON and send to server
-      string response = Transmit(string.Format(TraktURIs.ScrobbleShow, status), scrobbleData.ToJSON());
-
-      // return success or failure
-      return response.FromJSON<TraktResponse>();
+      return new TraktAuthentication { Username = Username, Password = Password }.ToJSON();
     }
 
     #endregion
 
-    #region Syncing
+    #region Sync
 
-    /// <summary>
-    /// Sends movie sync data to Trakt
-    /// </summary>
-    /// <param name="syncData">The sync data to send</param>
-    /// <param name="mode">The sync mode to use</param>
-    /// <returns>The response from trakt</returns>
-    public static TraktSyncResponse SyncMovieLibrary(TraktMovieSync syncData, TraktSyncModes mode)
+    public static TraktLastSyncActivities GetLastSyncActivities()
     {
-      // check that we have everything we need
-      // server can accept title/year if imdb id is not supplied
-      if (syncData == null || syncData.MovieList.Count == 0)
-      {
-        TraktSyncResponse error = new TraktSyncResponse
-        {
-          Error = "Not enough information to send to server",
-          Status = "failure"
-        };
-        return error;
-      }
+      var response = GetFromTrakt(TraktURIs.SyncLastActivities);
+      return response.FromJSON<TraktLastSyncActivities>();
+    }
 
-      // serialize Scrobble object to JSON and send to server
-      string response = Transmit(string.Format(TraktURIs.SyncMovieLibrary, mode), syncData.ToJSON());
+    #endregion
 
-      // return success or failure
-      return response.FromJSON<TraktSyncResponse>();
+    #region Playback
+
+    public static IEnumerable<TraktSyncPausedMovie> GetPausedMovies()
+    {
+      var response = GetFromTrakt(TraktURIs.SyncPausedMovies);
+      return response.FromJSONArray<TraktSyncPausedMovie>();
     }
 
-    /// <summary>
-    /// Add/Remove show to/from watchlist
-    /// </summary>
-    /// <param name="syncData">The sync data to send</param>
-    /// <param name="mode">The sync mode to use</param>
-    /// <returns>The response from trakt</returns>
-    public static TraktResponse SyncShowWatchList(TraktShowSync syncData, TraktSyncModes mode)
+    public static IEnumerable<TraktSyncPausedEpisode> GetPausedEpisodes()
     {
-      // check that we have everything we need            
-      if (syncData == null || syncData.Shows.Count == 0)
-      {
-        TraktResponse error = new TraktResponse
-        {
-          Error = "Not enough information to send to server",
-          Status = "failure"
-        };
-        return error;
-      }
+      var response = GetFromTrakt(TraktURIs.SyncPausedEpisodes);
+      return response.FromJSONArray<TraktSyncPausedEpisode>();
+    }
+
+    #endregion
 
-      // serialize Scrobble object to JSON and send to server
-      string response = Transmit(string.Format(TraktURIs.SyncShowWatchList, mode), syncData.ToJSON());
+    #region Collection
 
-      // return success or failure
-      return response.FromJSON<TraktResponse>();
+    public static IEnumerable<TraktMovieCollected> GetCollectedMovies()
+    {
+      var response = GetFromTrakt(TraktURIs.SyncCollectionMovies);
+      return response.FromJSONArray<TraktMovieCollected>();
     }
 
-    /// <summary>
-    /// Add/Remove episode to/from watchlist
-    /// </summary>
-    /// <param name="syncData">The sync data to send</param>
-    /// <param name="mode">The sync mode to use</param>
-    /// <returns>The response from trakt</returns>
-    public static TraktResponse SyncEpisodeWatchList(TraktEpisodeSync syncData, TraktSyncModes mode)
+    public static IEnumerable<TraktEpisodeCollected> GetCollectedEpisodes()
     {
-      // check that we have everything we need
-      if (syncData == null || syncData.EpisodeList.Count == 0)
-      {
-        TraktResponse error = new TraktResponse
-        {
-          Error = "Not enough information to send to server",
-          Status = "failure"
-        };
-        return error;
-      }
+      var response = GetFromTrakt(TraktURIs.SyncCollectionEpisodes);
+      return response.FromJSONArray<TraktEpisodeCollected>();
+    }
+
+    #endregion
 
-      // serialize Scrobble object to JSON and send to server
-      string response = Transmit(string.Format(TraktURIs.SyncEpisodeWatchList, mode), syncData.ToJSON());
+    #region Watched History
 
-      // return success or failure
-      return response.FromJSON<TraktResponse>();
+    public static IEnumerable<TraktMovieWatched> GetWatchedMovies()
+    {
+      var response = GetFromTrakt(TraktURIs.SyncWatchedMovies);
+      return response.FromJSONArray<TraktMovieWatched>();
     }
 
-    /// <summary>
-    /// Sends episode sync data to Trakt
-    /// </summary>
-    /// <param name="syncData">The sync data to send</param>
-    /// <param name="mode">The sync mode to use</param>
-    public static TraktResponse SyncEpisodeLibrary(TraktEpisodeSync syncData, TraktSyncModes mode)
+    public static IEnumerable<TraktEpisodeWatched> GetWatchedEpisodes()
     {
-      // check that we have everything we need
-      // server can accept title/year if imdb id is not supplied
-      if (syncData == null || string.IsNullOrEmpty(syncData.SeriesID) && string.IsNullOrEmpty(syncData.Title) && string.IsNullOrEmpty(syncData.Year))
-      {
-        TraktResponse error = new TraktResponse
-        {
-          Error = "Not enough information to send to server",
-          Status = "failure"
-        };
-        return error;
-      }
+      var response = GetFromTrakt(TraktURIs.SyncWatchedEpisodes);
+      return response.FromJSONArray<TraktEpisodeWatched>();
+    }
 
-      // serialize Scrobble object to JSON and send to server
-      string response = Transmit(string.Format(TraktURIs.SyncEpisodeLibrary, mode), syncData.ToJSON());
+    #endregion
 
-      // return success or failure
-      return response.FromJSON<TraktResponse>();
-    }
+    #region Ratings
 
-    public static TraktResponse SyncShowAsSeen(TraktShowSeen show)
+    public static IEnumerable<TraktMovieRated> GetRatedMovies()
     {
-      string response = Transmit(TraktURIs.ShowSeen, show.ToJSON());
-      return response.FromJSON<TraktResponse>();
+      var response = GetFromTrakt(TraktURIs.SyncRatedMovies);
+      return response.FromJSONArray<TraktMovieRated>();
     }
 
-    public static TraktResponse SyncSeasonAsSeen(TraktSeasonSeen showSeason)
+    public static IEnumerable<TraktEpisodeRated> GetRatedEpisodes()
     {
-      string response = Transmit(TraktURIs.SeasonSeen, showSeason.ToJSON());
-      return response.FromJSON<TraktResponse>();
+      var response = GetFromTrakt(TraktURIs.SyncRatedEpisodes);
+      return response.FromJSONArray<TraktEpisodeRated>();
     }
 
-    public static TraktResponse SyncShowAsLibrary(TraktShowLibrary show)
+    public static IEnumerable<TraktShowRated> GetRatedShows()
     {
-      string response = Transmit(TraktURIs.ShowLibrary, show.ToJSON());
-      return response.FromJSON<TraktResponse>();
+      var response = GetFromTrakt(TraktURIs.SyncRatedShows);
+      return response.FromJSONArray<TraktShowRated>();
     }
 
-    public static TraktResponse SyncSeasonAsLibrary(TraktSeasonLibrary showSeason)
+    public static IEnumerable<TraktSeasonRated> GetRatedSeasons()
     {
-      string response = Transmit(TraktURIs.SeasonLibrary, showSeason.ToJSON());
-      return response.FromJSON<TraktResponse>();
+      var response = GetFromTrakt(TraktURIs.SyncRatedSeasons);
+      return response.FromJSONArray<TraktSeasonRated>();
     }
 
     #endregion
 
-    #region Trakt Library Calls
+    #region User
 
-    /// <summary>
-    /// Gets the trakt movie library for a user
-    /// </summary>
-    /// <param name="user">The user to get</param>
-    /// <returns>The trakt movie library</returns>
-    public static IEnumerable<TraktLibraryMovies> GetMovieCollectionForUser(string user)
+    public static TraktUserStatistics GetUserStatistics(string user)
     {
-      // get the library
-      string moviesForUser = Transmit(string.Format(TraktURIs.UserMoviesCollection, user), GetUserAuthentication());
-
-      // if we timeout we will return an error response
-      TraktResponse response = moviesForUser.FromJSON<TraktResponse>();
-      if (response == null || response.Error != null) return null;
-
-      return moviesForUser.FromJSONArray<TraktLibraryMovies>();
+      var response = GetFromTrakt(string.Format(TraktURIs.UserStats, user));
+      return response.FromJSON<TraktUserStatistics>();
     }
 
-    public static IEnumerable<TraktLibraryMovies> GetAllMoviesForUser(string user)
+    public static TraktUserSummary GetUserProfile(string user)
     {
-      return GetAllMoviesForUser(user, true);
+      var response = GetFromTrakt(string.Format(TraktURIs.UserProfile, user));
+      return response.FromJSON<TraktUserSummary>();
     }
 
     /// <summary>
-    /// Gets all movies for a user from trakt, including movies not in collection
+    /// Gets a list of follower requests for the current user
     /// </summary>
-    /// <param name="user">The user to get</param>
-    /// <param name="syncDataOnly">set this to true (default) if you want the absolute minimum data returned nessacary for syncing</param>
-    /// <returns>The trakt movie library</returns>
-    public static IEnumerable<TraktLibraryMovies> GetAllMoviesForUser(string user, bool syncDataOnly)
+    /// <returns></returns>
+    public static IEnumerable<TraktFollowerRequest> GetFollowerRequests()
     {
-      // Get the library
-      string moviesForUser = Transmit(string.Format(TraktURIs.UserMoviesAll, user, syncDataOnly ? @"/min" : string.Empty), GetUserAuthentication());
-
-      // if we timeout we will return an error response
-      TraktResponse response = moviesForUser.FromJSON<TraktResponse>();
-      if (response == null || response.Error != null) return null;
+      var response = GetFromTrakt(TraktURIs.UserFollowerRequests);
+      return response.FromJSONArray<TraktFollowerRequest>();
+    }
 
-      return moviesForUser.FromJSONArray<TraktLibraryMovies>();
+    /// <summary>
+    /// Returns a list of Friends for current user
+    /// Friends are a two-way relationship ie. both following each other
+    /// </summary>
+    public static IEnumerable<TraktNetworkFriend> GetNetworkFriends()
+    {
+      return GetNetworkFriends(TraktSettings.Username);
     }
 
-    public static IEnumerable<TraktLibraryShow> GetLibraryEpisodesForUser(string user)
+    public static IEnumerable<TraktNetworkFriend> GetNetworkFriends(string user)
     {
-      return GetLibraryEpisodesForUser(user, true);
+      string response = GetFromTrakt(string.Format(TraktURIs.NetworkFriends, user));
+      return response.FromJSONArray<TraktNetworkFriend>();
     }
 
     /// <summary>
-    /// Gets the trakt episode library for a user
+    /// Returns a list of people the current user follows
     /// </summary>
-    /// <param name="user">The user to get</param>
-    /// <param name="syncDataOnly">set this to true (default) if you want the absolute minimum data returned nessacary for syncing</param>
-    /// <returns>The trakt episode library</returns>
-    public static IEnumerable<TraktLibraryShow> GetLibraryEpisodesForUser(string user, bool syncDataOnly)
+    public static IEnumerable<TraktNetworkUser> GetNetworkFollowing()
     {
-      string showsForUser = Transmit(string.Format(TraktURIs.UserEpisodesCollection, user, syncDataOnly ? @"/min" : string.Empty), GetUserAuthentication());
-
-      // if we timeout we will return an error response
-      TraktResponse response = showsForUser.FromJSON<TraktResponse>();
-      if (response == null || response.Error != null) return null;
-
-      return showsForUser.FromJSONArray<TraktLibraryShow>();
+      return GetNetworkFollowing(TraktSettings.Username);
     }
 
-    public static IEnumerable<TraktLibraryShow> GetWatchedEpisodesForUser(string user)
+    public static IEnumerable<TraktNetworkUser> GetNetworkFollowing(string user)
     {
-      return GetWatchedEpisodesForUser(user, true);
+      string response = GetFromTrakt(string.Format(TraktURIs.NetworkFollowing, user));
+      return response.FromJSONArray<TraktNetworkUser>();
     }
 
     /// <summary>
-    /// Gets the trakt watched/seen episodes for a user
+    /// Returns a list of people that follow the current user
     /// </summary>
-    /// <param name="user">The user to get</param>
-    /// <param name="syncDataOnly">set this to true (default) if you want the absolute minimum data returned nessacary for syncing</param>
-    /// <returns>The trakt episode library</returns>
-    public static IEnumerable<TraktLibraryShow> GetWatchedEpisodesForUser(string user, bool syncDataOnly)
+    public static IEnumerable<TraktNetworkUser> GetNetworkFollowers()
     {
-      string showsForUser = Transmit(string.Format(TraktURIs.UserWatchedEpisodes, user, syncDataOnly ? @"/min" : string.Empty), GetUserAuthentication());
-
-      // if we timeout we will return an error response
-      TraktResponse response = showsForUser.FromJSON<TraktResponse>();
-      if (response == null || response.Error != null) return null;
-
-      return showsForUser.FromJSONArray<TraktLibraryShow>();
+      return GetNetworkFollowers(TraktSettings.Username);
     }
 
-    public static IEnumerable<TraktLibraryShow> GetUnSeenEpisodesForUser(string user)
+    public static IEnumerable<TraktNetworkUser> GetNetworkFollowers(string user)
     {
-      return GetUnSeenEpisodesForUser(user, true);
+      string response = GetFromTrakt(string.Format(TraktURIs.NetworkFollowers, user));
+      return response.FromJSONArray<TraktNetworkUser>();
     }
 
-    public static IEnumerable<TraktLibraryShow> GetUnSeenEpisodesForUser(string user, bool syncDataOnly)
+    public static TraktNetworkUser NetworkApproveFollower(int id)
     {
-      string showsForUser = Transmit(string.Format(TraktURIs.UserEpisodesUnSeen, user, syncDataOnly ? @"/min" : string.Empty), GetUserAuthentication());
-
-      // if we timeout we will return an error response
-      TraktResponse response = showsForUser.FromJSON<TraktResponse>();
-      if (response == null || response.Error != null) return null;
-
-      return showsForUser.FromJSONArray<TraktLibraryShow>();
+      string response = PostToTrakt(string.Format(TraktURIs.NetworkFollowRequest, id), string.Empty);
+      return response.FromJSON<TraktNetworkUser>();
     }
 
-    #endregion
-
-    #region Rating
-
-    /// <summary>
-    /// Sends episode rate data to Trakt
-    /// </summary>
-    /// <param name="episode">The Trakt rate data to send</param>
-    /// <returns>The response from Trakt</returns>
-    public static TraktRateResponse RateEpisode(TraktRateEpisode episode)
+    public static bool NetworkDenyFollower(int id)
     {
-      if (episode == null) return null;
-      string response = Transmit(string.Format(TraktURIs.RateItem, TraktItemType.episode), episode.ToJSON());
-      return response.FromJSON<TraktRateResponse>();
+      return DeleteFromTrakt(string.Format(TraktURIs.NetworkFollowRequest, id));
     }
 
-    /// <summary>
-    /// Sends episodes rate data to Trakt
-    /// </summary>
-    /// <param name="episodes">The Trakt rate data to send</param>
-    /// <returns>The response from Trakt</returns>
-    public static TraktRateResponse RateEpisodes(TraktRateEpisodes episodes)
+    public static TraktNetworkApproval NetworkFollowUser(string username)
     {
-      if (episodes == null) return null;
-      string response = Transmit(TraktURIs.RateEpisodes, episodes.ToJSON());
-      return response.FromJSON<TraktRateResponse>();
+      string response = PostToTrakt(string.Format(TraktURIs.NetworkFollowUser, username), string.Empty);
+      return response.FromJSON<TraktNetworkApproval>();
     }
 
-    /// <summary>
-    /// Sends series rate data to Trakt
-    /// </summary>
-    /// <param name="series">The Trakt rate data to send</param>
-    /// <returns>The response from Trakt</returns>
-    public static TraktRateResponse RateSeries(TraktRateSeries series)
+    public static bool NetworkUnFollowUser(string username)
     {
-      if (series == null) return null;
-      string response = Transmit(string.Format(TraktURIs.RateItem, TraktItemType.show.ToString()), series.ToJSON());
-      return response.FromJSON<TraktRateResponse>();
+      return DeleteFromTrakt(string.Format(TraktURIs.NetworkFollowUser, username));
     }
 
-    /// <summary>
-    /// Sends multiple series rate data to Trakt
-    /// </summary>
-    /// <param name="shows">The Trakt rate data to send</param>
-    /// <returns>The response from Trakt</returns>
-    public static TraktRateResponse RateSeries(TraktRateShows shows)
+    public static IEnumerable<TraktMovieHistory> GetUsersMovieWatchedHistory(string username, int page = 1, int maxItems = 100)
     {
-      if (shows == null) return null;
-      string response = Transmit(TraktURIs.RateShows, shows.ToJSON());
-      return response.FromJSON<TraktRateResponse>();
+      var response = GetFromTrakt(string.Format(TraktURIs.UserWatchedHistoryMovies, username, page, maxItems));
+      return response.FromJSONArray<TraktMovieHistory>();
     }
 
-    /// <summary>
-    /// Sends movie rate data to Trakt
-    /// </summary>
-    /// <param name="movie">The Trakt rate data to send</param>
-    /// <returns>The response from Trakt</returns>
-    public static TraktRateResponse RateMovie(TraktRateMovie movie)
+    public static IEnumerable<TraktEpisodeHistory> GetUsersEpisodeWatchedHistory(string username, int page = 1, int maxItems = 100)
     {
-      if (movie == null) return null;
-      string response = Transmit(string.Format(TraktURIs.RateItem, TraktItemType.movie), movie.ToJSON());
-      return response.FromJSON<TraktRateResponse>();
+      var response = GetFromTrakt(string.Format(TraktURIs.UserWatchedHistoryEpisodes, username, page, maxItems));
+      return response.FromJSONArray<TraktEpisodeHistory>();
     }
 
     /// <summary>
-    /// Sends movies rate data to Trakt
+    /// Get comments for user sorted by most recent
     /// </summary>
-    /// <param name="movies">The Trakt rate data to send</param>
-    /// <returns>The response from Trakt</returns>
-    public static TraktRateResponse RateMovies(TraktRateMovies movies)
+    /// <param name="username">Username of person that made comment</param>
+    /// <param name="commentType">all, reviews, shouts</param>
+    /// <param name="type"> all, movies, shows, seasons, episodes, lists</param>
+    public static TraktComments GetUsersComments(string username, string commentType = "all", string type = "all", string extendedInfoParams = "min", int page = 1, int maxItems = 10)
     {
-      if (movies == null) return null;
-      string response = Transmit(TraktURIs.RateMovies, movies.ToJSON());
-      return response.FromJSON<TraktRateResponse>();
+      var headers = new WebHeaderCollection();
+
+      var response = GetFromTrakt(string.Format(TraktURIs.UserComments, username, commentType, type, extendedInfoParams, page, maxItems), out headers);
+      if (response == null)
+        return null;
+
+      try
+      {
+        return new TraktComments
+        {
+          CurrentPage = page,
+          TotalItemsPerPage = maxItems,
+          TotalPages = int.Parse(headers["X-Pagination-Page-Count"]),
+          TotalItems = int.Parse(headers["X-Pagination-Item-Count"]),
+          Comments = response.FromJSONArray<TraktCommentItem>()
+        };
+      }
+      catch
+      {
+        // most likely bad header response
+        return null;
+      }
     }
 
     #endregion
 
-    #region User
+    #region Lists
 
-    public static TraktUserProfile GetUserProfile(string user)
+    public static IEnumerable<TraktListDetail> GetUserLists(string username)
     {
-      string response = Transmit(string.Format(TraktURIs.UserProfile, user), GetUserAuthentication());
-      return response.FromJSON<TraktUserProfile>();
+      var response = GetFromTrakt(string.Format(TraktURIs.UserLists, username));
+      return response.FromJSONArray<TraktListDetail>();
     }
 
-    /// <summary>
-    /// Returns a list of Friends and their user profiles
-    /// </summary>
-    /// <param name="user">username of person to retrieve friend s list</param>
-    public static IEnumerable<TraktUserProfile> GetUserFriends(string user)
+    public static IEnumerable<TraktListItem> GetUserListItems(string username, string listId, string extendedInfoParams = "min")
     {
-      string response = Transmit(string.Format(TraktURIs.UserFriends, user), GetUserAuthentication());
-      return response.FromJSONArray<TraktUserProfile>();
+      var response = GetFromTrakt(string.Format(TraktURIs.UserListItems, username, listId, extendedInfoParams));
+      return response.FromJSONArray<TraktListItem>();
     }
 
-    /// <summary>
-    /// Returns list of episodes in Users Calendar
-    /// </summary>
-    /// <param name="user">username of person to get Calendar</param>
-    public static IEnumerable<TraktCalendar> GetCalendarForUser(string user)
+    public static TraktListDetail CreateCustomList(TraktList list, string username)
     {
-      // 7-Days from Today
-      // All Dates should be in PST (GMT-8)
-      DateTime dateNow = DateTime.UtcNow.Subtract(new TimeSpan(8, 0, 0));
-      return GetCalendarForUser(user, dateNow.ToString("yyyyMMdd"), "7");
+      var response = PostToTrakt(string.Format(TraktURIs.UserListAdd, username), list.ToJSON());
+      return response.FromJSON<TraktListDetail>();
     }
 
-    /// <summary>
-    /// Returns list of episodes in Users Calendar
-    /// </summary>
-    /// <param name="user">username of person to get Calendar</param>
-    /// <param name="startDate">Start Date of calendar in form yyyyMMdd (GMT-8hrs)</param>
-    /// <param name="days">Number of days to return in calendar</param>
-    public static IEnumerable<TraktCalendar> GetCalendarForUser(string user, string startDate, string days)
+    public static TraktListDetail UpdateCustomList(TraktListDetail list, string username)
     {
-      string userCalendar = Transmit(string.Format(TraktURIs.UserCalendarShows, user, startDate, days), GetUserAuthentication());
-      return userCalendar.FromJSONArray<TraktCalendar>();
+      var response = ReplaceOnTrakt(string.Format(TraktURIs.UserListEdit, username), list.ToJSON());
+      return response.FromJSON<TraktListDetail>();
     }
 
-    public static IEnumerable<TraktCalendar> GetCalendarPremieres()
+    public static TraktSyncResponse AddItemsToList(string username, string id, TraktSyncAll items)
     {
-      // 7-Days from Today
-      // All Dates should be in PST (GMT-8)
-      DateTime dateNow = DateTime.UtcNow.Subtract(new TimeSpan(8, 0, 0));
-      return GetCalendarPremieres(dateNow.ToString("yyyyMMdd"), "7");
+      var response = PostToTrakt(string.Format(TraktURIs.UserListItemsAdd, username, id), items.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
     }
 
-    /// <summary>
-    /// Returns list of episodes in the Premieres Calendar
-    /// </summary>        
-    /// <param name="startDate">Start Date of calendar in form yyyyMMdd (GMT-8hrs)</param>
-    /// <param name="days">Number of days to return in calendar</param>
-    public static IEnumerable<TraktCalendar> GetCalendarPremieres(string startDate, string days)
+    public static TraktSyncResponse RemoveItemsFromList(string username, string id, TraktSyncAll items)
     {
-      string premieres = Transmit(string.Format(TraktURIs.CalendarPremieres, startDate, days), GetUserAuthentication());
-      return premieres.FromJSONArray<TraktCalendar>();
+      var response = PostToTrakt(string.Format(TraktURIs.UserListItemsRemove, username, id), items.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
     }
 
-    public static IEnumerable<TraktCalendar> GetCalendarShows()
+    public static bool DeleteUserList(string username, string listId)
     {
-      DateTime dateNow = DateTime.UtcNow.Subtract(new TimeSpan(8, 0, 0));
-      return GetCalendarShows(dateNow.ToString("yyyyMMdd"), "7");
+      return DeleteFromTrakt(string.Format(TraktURIs.DeleteList, username, listId));
     }
 
-    public static IEnumerable<TraktCalendar> GetCalendarShows(string startDate, string days)
+    public static bool LikeList(string username, int id)
     {
-      string premieres = Transmit(string.Format(TraktURIs.CalendarAllShows, startDate, days), GetUserAuthentication());
-      return premieres.FromJSONArray<TraktCalendar>();
+      var response = PostToTrakt(string.Format(TraktURIs.UserListLike, username, id), null);
+      return response != null;
     }
 
-    /// <summary>
-    /// Returns list of the 100 last watched episodes by a user
-    /// </summary>
-    /// <param name="user">username of person to get watched history</param>
-    [Obsolete("This method is deprecated and has been replaced by GetUserActivity", false)]
-    public static IEnumerable<TraktWatchedEpisode> GetUserEpisodeWatchedHistory(string user)
+    public static bool UnLikeList(string username, int id)
     {
-      string watchedEpisodes = Transmit(string.Format(TraktURIs.UserEpisodeWatchedHistory, user), GetUserAuthentication());
-      return watchedEpisodes.FromJSONArray<TraktWatchedEpisode>();
+      return DeleteFromTrakt(string.Format(TraktURIs.UserListLike, username, id));
     }
 
-    /// <summary>
-    /// Returns list of the 100 last watched movies by a user
-    /// </summary>
-    /// <param name="user">username of person to get watched history</param>
-    [Obsolete("This method is deprecated and has been replaced by GetUserActivity", false)]
-    public static IEnumerable<TraktWatchedMovie> GetUserMovieWatchedHistory(string user)
+    #endregion
+
+    #region Watchlists
+
+    public static IEnumerable<TraktMovieWatchList> GetWatchListMovies(string username, string extendedInfoParams = "min")
     {
-      string watchedMovies = Transmit(string.Format(TraktURIs.UserMovieWatchedHistory, user), GetUserAuthentication());
-      return watchedMovies.FromJSONArray<TraktWatchedMovie>();
+      var response = GetFromTrakt(string.Format(TraktURIs.UserWatchlistMovies, username, extendedInfoParams));
+      return response.FromJSONArray<TraktMovieWatchList>();
     }
 
-    /// <summary>
-    /// Returns a list of lists created by user
-    /// </summary>
-    /// <param name="user">username of person to get lists</param>
-    public static IEnumerable<TraktUserList> GetUserLists(string user)
+    public static IEnumerable<TraktShowWatchList> GetWatchListShows(string username, string extendedInfoParams = "min")
     {
-      string userLists = Transmit(string.Format(TraktURIs.UserLists, user), GetUserAuthentication());
-      return userLists.FromJSONArray<TraktUserList>();
+      var response = GetFromTrakt(string.Format(TraktURIs.UserWatchlistShows, username, extendedInfoParams));
+      return response.FromJSONArray<TraktShowWatchList>();
     }
 
-    /// <summary>
-    /// Returns the contents of a lists for a user
-    /// </summary>
-    /// <param name="user">username of person</param>
-    /// <param name="slug">slug (id) of list item e.g. "star-wars-collection"</param>
-    public static TraktUserList GetUserList(string user, string slug)
+    public static IEnumerable<TraktSeasonWatchList> GetWatchListSeasons(string username, string extendedInfoParams = "min")
     {
-      string userList = Transmit(string.Format(TraktURIs.UserList, user, slug), GetUserAuthentication());
-      return userList.FromJSON<TraktUserList>();
+      var response = GetFromTrakt(string.Format(TraktURIs.UserWatchlistSeasons, username, extendedInfoParams));
+      return response.FromJSONArray<TraktSeasonWatchList>();
     }
 
-    /// <summary>
-    /// Returns the users Rated Movies
-    /// </summary>
-    /// <param name="user">username of person</param>
-    public static IEnumerable<TraktUserMovieRating> GetUserRatedMovies(string user)
+    public static IEnumerable<TraktEpisodeWatchList> GetWatchListEpisodes(string username, string extendedInfoParams = "min")
     {
-      string ratedMovies = Transmit(string.Format(TraktURIs.UserRatedMoviesList, user), GetUserAuthentication());
+      var response = GetFromTrakt(string.Format(TraktURIs.UserWatchlistEpisodes, username, extendedInfoParams));
+      return response.FromJSONArray<TraktEpisodeWatchList>();
+    }
 
-      // if we timeout we will return an error response
-      TraktResponse response = ratedMovies.FromJSON<TraktResponse>();
-      if (response == null || response.Error != null) return null;
+    #endregion
 
-      return ratedMovies.FromJSONArray<TraktUserMovieRating>();
-    }
+    #region Likes
 
     /// <summary>
-    /// Returns the users Rated Shows
+    /// Gets the current users liked items (comments and/or lists)
     /// </summary>
-    /// <param name="user">username of person</param>
-    public static IEnumerable<TraktUserShowRating> GetUserRatedShows(string user)
+    /// <param name="type">The type of liked item: all (default), lists or comments</param>
+    /// <param name="extendedInfoParams">Extended Info: min, full, images (comma separated)</param>
+    /// <param name="page">Page Number</param>
+    /// <param name="maxItems">Maximum number of items to request per page (this should be consistent per page request)</param>
+    public static TraktLikes GetLikedItems(string type = "all", string extendedInfoParams = "min", int page = 1, int maxItems = 10)
     {
-      string ratedShows = Transmit(string.Format(TraktURIs.UserRatedShowsList, user), GetUserAuthentication());
+      var headers = new WebHeaderCollection();
 
-      // if we timeout we will return an error response
-      TraktResponse response = ratedShows.FromJSON<TraktResponse>();
-      if (response == null || response.Error != null) return null;
+      var response = GetFromTrakt(string.Format(TraktURIs.UserLikedItems, type, extendedInfoParams, page, maxItems), out headers);
+      if (response == null)
+        return null;
 
-      return ratedShows.FromJSONArray<TraktUserShowRating>();
+      try
+      {
+        return new TraktLikes
+        {
+          CurrentPage = page,
+          TotalItemsPerPage = maxItems,
+          TotalPages = int.Parse(headers["X-Pagination-Page-Count"]),
+          TotalItems = int.Parse(headers["X-Pagination-Item-Count"]),
+          Likes = response.FromJSONArray<TraktLike>()
+        };
+      }
+      catch
+      {
+        // most likely bad header response
+        return null;
+      }
     }
 
-    /// <summary>
-    /// Returns the users Rated Episodes
-    /// </summary>
-    /// <param name="user">username of person</param>
-    public static IEnumerable<TraktUserEpisodeRating> GetUserRatedEpisodes(string user)
-    {
-      string ratedEpisodes = Transmit(string.Format(TraktURIs.UserRatedEpisodesList, user), GetUserAuthentication());
+    #endregion
 
-      // if we timeout we will return an error response
-      TraktResponse response = ratedEpisodes.FromJSON<TraktResponse>();
-      if (response == null || response.Error != null) return null;
+    #region Movies
 
-      return ratedEpisodes.FromJSONArray<TraktUserEpisodeRating>();
+    #region Related
+
+    public static IEnumerable<TraktMovieSummary> GetRelatedMovies(string id, int limit = 10)
+    {
+      var response = GetFromTrakt(string.Format(TraktURIs.RelatedMovies, id, limit));
+      return response.FromJSONArray<TraktMovieSummary>();
     }
 
     #endregion
 
-    #region Activity
+    #region Comments
 
-    public static TraktActivity GetFriendActivity()
+    public static IEnumerable<TraktComment> GetMovieComments(string id, int page = 1, int maxItems = 1000)
     {
-      return GetFriendActivity(null, null, false);
+      var response = GetFromTrakt(string.Format(TraktURIs.MovieComments, id, page, maxItems));
+      return response.FromJSONArray<TraktComment>();
     }
 
-    public static TraktActivity GetFriendActivity(bool includeMe)
-    {
-      return GetFriendActivity(null, null, includeMe);
-    }
+    #endregion
 
-    public static TraktActivity GetFriendActivity(List<ActivityType> types, List<ActivityAction> actions, bool includeMe)
-    {
-      return GetFriendActivity(types, actions, 0, 0, includeMe);
-    }
+    #region Popular
 
-    public static TraktActivity GetFriendActivity(List<ActivityType> types, List<ActivityAction> actions, long start, long end, bool includeMe)
+    public static TraktMoviesPopular GetPopularMovies(int page = 1, int maxItems = 100)
     {
-      // get comma seperated list of types and actions (if more than one)
-      string activityTypes = types == null ? "all" : string.Join(",", types.Select(t => t.ToString()).ToArray());
-      string activityActions = actions == null ? "all" : string.Join(",", actions.Select(a => a.ToString()).ToArray());
+      var headers = new WebHeaderCollection();
 
-      string startEnd = (start == 0 || end == 0) ? string.Empty : string.Format("/{0}/{1}", start, end);
-      string apiUrl = includeMe ? TraktURIs.ActivityFriendsMe : TraktURIs.ActivityFriends;
+      var response = GetFromTrakt(string.Format(TraktURIs.PopularMovies, page, maxItems), out headers);
+      if (response == null)
+        return null;
 
-      string activity = Transmit(string.Format(apiUrl, activityTypes, activityActions, startEnd), GetUserAuthentication());
-      return activity.FromJSON<TraktActivity>();
+      try
+      {
+        return new TraktMoviesPopular
+        {
+          CurrentPage = page,
+          TotalItemsPerPage = maxItems,
+          Movies = response.FromJSONArray<TraktMovieSummary>()
+        };
+      }
+      catch
+      {
+        // most likely bad header response
+        return null;
+      }
     }
 
-    public static TraktActivity GetCommunityActivity()
+    #endregion
+
+    #region Trending
+
+    public static TraktMoviesTrending GetTrendingMovies(int page = 1, int maxItems = 100)
     {
-      return GetCommunityActivity(null, null);
+      var headers = new WebHeaderCollection();
+
+      var response = GetFromTrakt(string.Format(TraktURIs.TrendingMovies, page, maxItems), out headers);
+      if (response == null)
+        return null;
+
+      try
+      {
+        return new TraktMoviesTrending
+        {
+          CurrentPage = page,
+          TotalItemsPerPage = maxItems,
+          TotalPages = int.Parse(headers["X-Pagination-Page-Count"]),
+          TotalItems = int.Parse(headers["X-Pagination-Item-Count"]),
+          TotalWatchers = int.Parse(headers["X-Trending-User-Count"]),
+          Movies = response.FromJSONArray<TraktMovieTrending>()
+        };
+      }
+      catch
+      {
+        // most likely bad header response
+        return null;
+      }
     }
 
-    public static TraktActivity GetCommunityActivity(List<ActivityType> types, List<ActivityAction> actions)
+    #endregion
+
+    #region Recommendations
+
+    public static IEnumerable<TraktMovieSummary> GetRecommendedMovies(string extendedInfoParams = "min")
     {
-      return GetCommunityActivity(types, actions, 0, 0);
+      var response = GetFromTrakt(string.Format(TraktURIs.RecommendedMovies, extendedInfoParams));
+      return response.FromJSONArray<TraktMovieSummary>();
     }
 
-    public static TraktActivity GetCommunityActivity(List<ActivityType> types, List<ActivityAction> actions, long start, long end)
+    public static bool DismissRecommendedMovie(string movieId)
     {
-      // get comma seperated list of types and actions (if more than one)
-      string activityTypes = types == null ? "all" : string.Join(",", types.Select(t => t.ToString()).ToArray());
-      string activityActions = actions == null ? "all" : string.Join(",", actions.Select(a => a.ToString()).ToArray());
+      return DeleteFromTrakt(string.Format(TraktURIs.DismissRecommendedMovie, movieId));
+    }
 
-      string startEnd = (start == 0 || end == 0) ? string.Empty : string.Format("/{0}/{1}", start, end);
+    #endregion
 
-      string activity = Transmit(string.Format(TraktURIs.ActivityCommunity, activityTypes, activityActions, startEnd), GetUserAuthentication());
-      return activity.FromJSON<TraktActivity>();
-    }
+    #region Updates
 
-    public static TraktActivity GetUserActivity(string username, List<ActivityType> types, List<ActivityAction> actions)
+    public static TraktMoviesUpdated GetRecentlyUpdatedMovies(string sincedate, int page = 1, int maxItems = 100)
     {
-      // get comma seperated list of types and actions (if more than one)
-      string activityTypes = string.Join(",", types.Select(t => t.ToString()).ToArray());
-      string activityActions = string.Join(",", actions.Select(a => a.ToString()).ToArray());
+      var headers = new WebHeaderCollection();
+
+      var response = GetFromTrakt(string.Format(TraktURIs.MovieUpdates, sincedate, page, maxItems), out headers);
+      if (response == null)
+        return null;
 
-      string activity = Transmit(string.Format(TraktURIs.ActivityUser, username, activityTypes, activityActions), GetUserAuthentication());
-      return activity.FromJSON<TraktActivity>();
+      try
+      {
+        return new TraktMoviesUpdated
+        {
+          CurrentPage = page,
+          TotalItemsPerPage = maxItems,
+          TotalPages = int.Parse(headers["X-Pagination-Page-Count"]),
+          TotalItems = int.Parse(headers["X-Pagination-Item-Count"]),
+          Movies = response.FromJSONArray<TraktMovieUpdate>()
+        };
+      }
+      catch
+      {
+        // most likely bad header response
+        return null;
+      }
     }
 
     #endregion
 
-    #region Friends / Network
+    #endregion
 
-    /// <summary>
-    /// Returns a list of Friends for current user
-    /// Friends are a two-way relationship ie. both following each other
-    /// </summary>
-    public static IEnumerable<TraktNetworkUser> GetNetworkFriends()
-    {
-      return GetNetworkFriends(TraktSettings.Username);
-    }
-    public static IEnumerable<TraktNetworkUser> GetNetworkFriends(string person)
-    {
-      string response = Transmit(string.Format(TraktURIs.NetworkFriends, person), GetUserAuthentication());
-      return response.FromJSONArray<TraktNetworkUser>();
-    }
+    #region Shows
 
-    /// <summary>
-    /// Returns a list of people the current user follows
-    /// </summary>
-    public static IEnumerable<TraktNetworkUser> GetNetworkFollowing()
-    {
-      return GetNetworkFollowing(TraktSettings.Username);
-    }
-    public static IEnumerable<TraktNetworkUser> GetNetworkFollowing(string person)
+    #region Related
+
+    public static IEnumerable<TraktShowSummary> GetRelatedShows(string id, int limit = 10)
     {
-      string response = Transmit(string.Format(TraktURIs.NetworkFollowing, person), GetUserAuthentication());
-      return response.FromJSONArray<TraktNetworkUser>();
+      var response = GetFromTrakt(string.Format(TraktURIs.RelatedShows, id, limit));
+      return response.FromJSONArray<TraktShowSummary>();
     }
 
-    /// <summary>
-    /// Returns a list of people that follow the current user
-    /// </summary>
-    public static IEnumerable<TraktNetworkUser> GetNetworkFollowers()
+    #endregion
+
+    #region Summary
+
+    public static TraktShowSummary GetShowSummary(string id)
     {
-      return GetNetworkFollowers(TraktSettings.Username);
+      var response = GetFromTrakt(string.Format(TraktURIs.ShowSummary, id));
+      return response.FromJSON<TraktShowSummary>();
     }
-    public static IEnumerable<TraktNetworkUser> GetNetworkFollowers(string person)
+
+    #endregion
+
+    #region Updates
+
+    public static TraktShowsUpdated GetRecentlyUpdatedShows(string sincedate, int page = 1, int maxItems = 100)
     {
-      string response = Transmit(string.Format(TraktURIs.NetworkFollowers, person), GetUserAuthentication());
-      return response.FromJSONArray<TraktNetworkUser>();
+      var headers = new WebHeaderCollection();
+
+      var response = GetFromTrakt(string.Format(TraktURIs.ShowUpdates, sincedate, page, maxItems), out headers);
+      if (response == null)
+        return null;
+
+      try
+      {
+        return new TraktShowsUpdated
+        {
+          CurrentPage = page,
+          TotalItemsPerPage = maxItems,
+          TotalPages = int.Parse(headers["X-Pagination-Page-Count"]),
+          TotalItems = int.Parse(headers["X-Pagination-Item-Count"]),
+          Shows = response.FromJSONArray<TraktShowUpdate>()
+        };
+      }
+      catch
+      {
+        // most likely bad header response
+        return null;
+      }
     }
 
+    #endregion
+
+    #region Seasons
+
     /// <summary>
-    /// Returns a list of people awaiting 'following' approval
+    /// Gets the seasons for a show
     /// </summary>
-    /// <returns></returns>
-    public static IEnumerable<TraktNetworkReqUser> GetNetworkRequests()
+    /// <param name="id">the id of the tv show</param>
+    /// <param name="extendedParameter">request parameters, "episodes,full,images"</param>
+    public static IEnumerable<TraktSeasonSummary> GetShowSeasons(string id, string extendedParameter = "full,images")
     {
-      string response = Transmit(TraktURIs.NetworkRequests, GetUserAuthentication());
-      return response.FromJSONArray<TraktNetworkReqUser>();
+      var response = GetFromTrakt(string.Format(TraktURIs.ShowSeasons, id, extendedParameter));
+      return response.FromJSONArray<TraktSeasonSummary>();
     }
 
-    public static TraktNetworkFollowResponse NetworkFollow(TraktNetwork person)
+    public static IEnumerable<TraktComment> GetSeasonComments(string id, int season, int page = 1, int maxItems = 1000)
     {
-      string response = Transmit(TraktURIs.NetworkFollow, person.ToJSON());
-      return response.FromJSON<TraktNetworkFollowResponse>();
+      var response = GetFromTrakt(string.Format(TraktURIs.SeasonComments, id, season, page, maxItems));
+      return response.FromJSONArray<TraktComment>();
     }
 
-    public static TraktResponse NetworkUnFollow(TraktNetwork person)
+    #endregion
+
+    #region Comments
+
+    public static IEnumerable<TraktComment> GetShowComments(string id, int page = 1, int maxItems = 1000)
     {
-      string response = Transmit(TraktURIs.NetworkUnFollow, person.ToJSON());
-      return response.FromJSON<TraktResponse>();
+      var response = GetFromTrakt(string.Format(TraktURIs.ShowComments, id, page, maxItems));
+      return response.FromJSONArray<TraktComment>();
     }
 
-    public static TraktResponse NetworkApprove(TraktNetworkApprove person)
+    #endregion
+
+    #region Popular
+
+    public static TraktShowsPopular GetPopularShows(int page = 1, int maxItems = 100)
     {
-      string response = Transmit(TraktURIs.NetworkApprove, person.ToJSON());
-      return response.FromJSON<TraktResponse>();
+      var headers = new WebHeaderCollection();
+
+      var response = GetFromTrakt(string.Format(TraktURIs.PopularShows, page, maxItems), out headers);
+      if (response == null)
+        return null;
+
+      try
+      {
+        return new TraktShowsPopular
+        {
+          CurrentPage = page,
+          TotalItemsPerPage = maxItems,
+          Shows = response.FromJSONArray<TraktShowSummary>()
+        };
+      }
+      catch
+      {
+        // most likely bad header response
+        return null;
+      }
     }
 
-    public static TraktResponse NetworkDeny(TraktNetwork person)
+    #endregion
+
+    #region Trending
+
+    public static TraktShowsTrending GetTrendingShows(int page = 1, int maxItems = 100)
     {
-      string response = Transmit(TraktURIs.NetworkDeny, person.ToJSON());
-      return response.FromJSON<TraktResponse>();
+      var headers = new WebHeaderCollection();
+
+      var response = GetFromTrakt(string.Format(TraktURIs.TrendingShows, page, maxItems), out headers);
+      if (response == null)
+        return null;
+
+      try
+      {
+        return new TraktShowsTrending
+        {
+          CurrentPage = page,
+          TotalItemsPerPage = maxItems,
+          TotalPages = int.Parse(headers["X-Pagination-Page-Count"]),
+          TotalItems = int.Parse(headers["X-Pagination-Item-Count"]),
+          TotalWatchers = int.Parse(headers["X-Trending-User-Count"]),
+          Shows = response.FromJSONArray<TraktShowTrending>()
+        };
+      }
+      catch
+      {
+        // most likely bad header response
+        return null;
+      }
     }
 
-    #region Obselete Methods
+    #endregion
+
+    #region Recommendations
 
-    [Obsolete("This method is now obsolete, use GetNetworkFriends()", false)]
-    public static IEnumerable<TraktUserProfile> GetFriends()
+    public static IEnumerable<TraktShowSummary> GetRecommendedShows()
     {
-      string response = Transmit(string.Format(TraktURIs.Friends, TraktSettings.Username), GetUserAuthentication());
-      return response.FromJSONArray<TraktUserProfile>();
+      var response = GetFromTrakt(TraktURIs.RecommendedShows);
+      return response.FromJSONArray<TraktShowSummary>();
     }
 
-    [Obsolete("This method is now obsolete, use GetNetworkRequests()", false)]
-    public static IEnumerable<TraktUserProfile> GetFriendRequests()
+    public static bool DismissRecommendedShow(string showId)
     {
-      string response = Transmit(TraktURIs.FriendRequests, GetUserAuthentication());
-      return response.FromJSONArray<TraktUserProfile>();
+      return DeleteFromTrakt(string.Format(TraktURIs.DismissRecommendedShow, showId));
     }
 
-    [Obsolete("This method is now obsolete, use NetworkApprove()", false)]
-    public static TraktResponse FriendApprove(TraktFriend friend)
+    #endregion
+
+    #region Calendar
+
+    /// <summary>
+    /// Returns list of episodes in the Calendar
+    /// </summary>
+    public static Dictionary<string, IEnumerable<TraktCalendar>> GetCalendarShows()
     {
-      string response = Transmit(TraktURIs.FriendApprove, friend.ToJSON());
-      return response.FromJSON<TraktResponse>();
+      // 7-Days from Today
+      DateTime dateNow = DateTime.UtcNow;
+      return GetCalendarShows(dateNow.ToString("yyyyMMdd"), "7", false);
     }
 
-    [Obsolete("This method is now obsolete, use NetworkFollow()", false)]
-    public static TraktResponse FriendAdd(TraktFriend friend)
+    /// <summary>
+    /// Returns list of episodes in the Calendar
+    /// </summary>
+    /// <param name="startDate">Start Date of calendar in form yyyyMMdd</param>
+    /// <param name="days">Number of days to return in calendar</param>
+    /// <param name="userCalendar">Set to true to get the calendar filtered by users shows in library</param>
+    public static Dictionary<string, IEnumerable<TraktCalendar>> GetCalendarShows(string startDate, string days, bool userCalendar)
     {
-      string response = Transmit(TraktURIs.FriendAdd, friend.ToJSON());
-      return response.FromJSON<TraktResponse>();
+      string calendar = GetFromTrakt(string.Format(TraktURIs.CalendarShows, startDate, days), "GET", userCalendar);
+      return calendar.FromJSONDictionary<Dictionary<string, IEnumerable<TraktCalendar>>>();
     }
 
-    [Obsolete("This method is now obsolete, use NetworkDeny()", false)]
-    public static TraktResponse FriendDeny(TraktFriend friend)
+    /// <summary>
+    /// Returns list of episodes in the Premieres Calendar
+    /// </summary>
+    public static Dictionary<string, IEnumerable<TraktCalendar>> GetCalendarPremieres()
     {
-      string response = Transmit(TraktURIs.FriendDeny, friend.ToJSON());
-      return response.FromJSON<TraktResponse>();
+      // 7-Days from Today
+      DateTime dateNow = DateTime.UtcNow;
+      return GetCalendarPremieres(dateNow.ToString("yyyyMMdd"), "7");
     }
 
-    [Obsolete("This method is now obsolete, use NetworkUnfollow()", false)]
-    public static TraktResponse FriendDelete(TraktFriend friend)
+    /// <summary>
+    /// Returns list of episodes in the Premieres Calendar
+    /// </summary>        
+    /// <param name="startDate">Start Date of calendar in form yyyyMMdd</param>
+    /// <param name="days">Number of days to return in calendar</param>
+    public static Dictionary<string, IEnumerable<TraktCalendar>> GetCalendarPremieres(string startDate, string days)
     {
-      string response = Transmit(TraktURIs.FriendDelete, friend.ToJSON());
-      return response.FromJSON<TraktResponse>();
+      string premieres = GetFromTrakt(string.Format(TraktURIs.CalendarPremieres, startDate, days));
+      return premieres.FromJSONDictionary<Dictionary<string, IEnumerable<TraktCalendar>>>();
     }
+
     #endregion
 
     #endregion
 
-    #region Trending
+    #region Episodes
 
-    public static IEnumerable<TraktTrendingMovie> GetTrendingMovies()
-    {
-      string response = Transmit(TraktURIs.TrendingMovies, GetUserAuthentication());
-      return response.FromJSONArray<TraktTrendingMovie>();
-    }
+    #region Comments
 
-    public static IEnumerable<TraktTrendingShow> GetTrendingShows()
+    public static IEnumerable<TraktComment> GetEpisodeComments(string id, int season, int episode, int page = 1, int maxItems = 1000)
     {
-      string response = Transmit(TraktURIs.TrendingShows, GetUserAuthentication());
-      return response.FromJSONArray<TraktTrendingShow>();
+      var response = GetFromTrakt(string.Format(TraktURIs.EpisodeComments, id, season, episode, page, maxItems));
+      return response.FromJSONArray<TraktComment>();
     }
 
     #endregion
 
-    #region Recommendations
+    #region Season Episodes
 
-    public static TraktResponse DismissMovieRecommendation(TraktMovieSlug movie)
+    public static IEnumerable<TraktEpisodeSummary> GetSeasonEpisodes(string showId, string seasonId)
     {
-      string response = Transmit(TraktURIs.DismissMovieRecommendation, movie.ToJSON());
-      return response.FromJSON<TraktResponse>();
+      var response = GetFromTrakt(string.Format(TraktURIs.SeasonEpisodes, showId, seasonId));
+      return response.FromJSONArray<TraktEpisodeSummary>();
     }
 
-    public static TraktResponse DismissShowRecommendation(TraktShowSlug show)
-    {
-      string response = Transmit(TraktURIs.DismissShowRecommendation, show.ToJSON());
-      return response.FromJSON<TraktResponse>();
-    }
+    #endregion
 
-    /// <summary>
-    /// Get Recommendations with out any filtering
-    /// </summary>
-    public static IEnumerable<TraktMovie> GetRecommendedMovies()
+    #endregion
+
+    #region Activity TODO
+
+    public static TraktActivity GetFriendActivity()
     {
-      string response = Transmit(TraktURIs.UserMovieRecommendations, GetUserAuthentication());
-      return response.FromJSONArray<TraktMovie>();
+      return GetFriendActivity(null, null, false);
     }
 
-    public static IEnumerable<TraktMovie> GetRecommendedMovies(string genre, bool hidecollected, bool hidewatchlisted, int startyear, int endyear)
+    public static TraktActivity GetFriendActivity(bool includeMe)
     {
-      var traktRecommendationPost = new TraktRecommendations
-      {
-        Username = TraktSettings.Username,
-        Password = TraktSettings.Password,
-        Genre = genre,
-        HideCollected = hidecollected,
-        HideWatchlisted = hidewatchlisted,
-        StartYear = startyear,
-        EndYear = endyear
-      };
-
-      string response = Transmit(TraktURIs.UserMovieRecommendations, traktRecommendationPost.ToJSON());
-      return response.FromJSONArray<TraktMovie>();
+      return GetFriendActivity(null, null, includeMe);
     }
 
-    /// <summary>
-    /// Get Recommendations with out any filtering
-    /// </summary>        
-    public static IEnumerable<TraktShow> GetRecommendedShows()
+    public static TraktActivity GetFriendActivity(List<ActivityType> types, List<ActivityAction> actions, bool includeMe)
     {
-      string response = Transmit(TraktURIs.UserShowsRecommendations, GetUserAuthentication());
-      return response.FromJSONArray<TraktShow>();
+      return GetFriendActivity(types, actions, 0, 0, includeMe);
     }
 
-    public static IEnumerable<TraktShow> GetRecommendedShows(string genre, bool hidecollected, bool hidewatchlisted, int startyear, int endyear)
+    public static TraktActivity GetFriendActivity(List<ActivityType> types, List<ActivityAction> actions, long start, long end, bool includeMe)
     {
-      var traktRecommendationPost = new TraktRecommendations
-      {
-        Username = TraktSettings.Username,
-        Password = TraktSettings.Password,
-        Genre = genre,
-        HideCollected = hidecollected,
-        HideWatchlisted = hidewatchlisted,
-        StartYear = startyear,
-        EndYear = endyear
-      };
-
-      string response = Transmit(TraktURIs.UserShowsRecommendations, traktRecommendationPost.ToJSON());
-      return response.FromJSONArray<TraktShow>();
-    }
+      //// get comma seperated list of types and actions (if more than one)
+      //string activityTypes = types == null ? "all" : string.Join(",", types.Select(t => t.ToString()).ToArray());
+      //string activityActions = actions == null ? "all" : string.Join(",", actions.Select(a => a.ToString()).ToArray());
 
-    #endregion
+      //string startEnd = (start == 0 || end == 0) ? string.Empty : string.Format("/{0}/{1}", start, end);
+      //string apiUrl = includeMe ? TraktURIs.ActivityFriendsMe : TraktURIs.ActivityFriends;
 
-    #region Watch List
+      //string activity = Transmit(string.Format(apiUrl, activityTypes, activityActions, startEnd), GetUserAuthentication());
+      //return activity.FromJSON<TraktActivity>();
+      return null;
+    }
 
-    public static IEnumerable<TraktWatchListMovie> GetWatchListMovies(string user)
+    public static TraktActivity GetFollowingActivity()
     {
-      string response = Transmit(string.Format(TraktURIs.UserMovieWatchList, user), GetUserAuthentication());
-      return response.FromJSONArray<TraktWatchListMovie>();
+      return GetFollowingActivity(null, null);
     }
 
-    public static IEnumerable<TraktWatchListShow> GetWatchListShows(string user)
+    public static TraktActivity GetFollowingActivity(List<ActivityType> types, List<ActivityAction> actions)
     {
-      string response = Transmit(string.Format(TraktURIs.UserShowsWatchList, user), GetUserAuthentication());
-      return response.FromJSONArray<TraktWatchListShow>();
+      return GetFollowingActivity(types, actions, 0, 0);
     }
 
-    public static IEnumerable<TraktWatchListEpisode> GetWatchListEpisodes(string user)
+    public static TraktActivity GetFollowingActivity(List<ActivityType> types, List<ActivityAction> actions, long start, long end)
     {
-      string response = Transmit(string.Format(TraktURIs.UserEpisodesWatchList, user), GetUserAuthentication());
-      return response.FromJSONArray<TraktWatchListEpisode>();
-    }
+      //// get comma seperated list of types and actions (if more than one)
+      //string activityTypes = types == null ? "all" : string.Join(",", types.Select(t => t.ToString()).ToArray());
+      //string activityActions = actions == null ? "all" : string.Join(",", actions.Select(a => a.ToString()).ToArray());
 
-    #endregion
+      //string startEnd = (start == 0 || end == 0) ? string.Empty : string.Format("/{0}/{1}", start, end);
 
-    #region Lists
+      //string activity = Transmit(string.Format(TraktURIs.ActivityFollowing, activityTypes, activityActions, startEnd), GetUserAuthentication());
+      //return activity.FromJSON<TraktActivity>();
+      return null;
+    }
 
-    public static TraktAddListResponse ListAdd(TraktList list)
+    public static TraktActivity GetFollowersActivity()
     {
-      string response = Transmit(TraktURIs.ListAdd, list.ToJSON());
-      return response.FromJSON<TraktAddListResponse>();
+      return GetFollowersActivity(null, null);
     }
 
-    public static TraktResponse ListDelete(TraktList list)
+    public static TraktActivity GetFollowersActivity(List<ActivityType> types, List<ActivityAction> actions)
     {
-      string response = Transmit(TraktURIs.ListDelete, list.ToJSON());
-      return response.FromJSON<TraktResponse>();
+      return GetFollowersActivity(types, actions, 0, 0);
     }
 
-    public static TraktResponse ListUpdate(TraktList list)
+    public static TraktActivity GetFollowersActivity(List<ActivityType> types, List<ActivityAction> actions, long start, long end)
     {
-      string response = Transmit(TraktURIs.ListUpdate, list.ToJSON());
-      return response.FromJSON<TraktResponse>();
+      //// get comma seperated list of types and actions (if more than one)
+      //string activityTypes = types == null ? "all" : string.Join(",", types.Select(t => t.ToString()).ToArray());
+      //string activityActions = actions == null ? "all" : string.Join(",", actions.Select(a => a.ToString()).ToArray());
+
+      //string startEnd = (start == 0 || end == 0) ? string.Empty : string.Format("/{0}/{1}", start, end);
+
+      //string activity = Transmit(string.Format(TraktURIs.ActivityFollowers, activityTypes, activityActions, startEnd), GetUserAuthentication());
+      //return activity.FromJSON<TraktActivity>();
+      return null;
     }
 
-    public static TraktSyncResponse ListAddItems(TraktList list)
+    public static TraktActivity GetCommunityActivity()
     {
-      string response = Transmit(TraktURIs.ListItemsAdd, list.ToJSON());
-      return response.FromJSON<TraktSyncResponse>();
+      return GetCommunityActivity(null, null);
     }
 
-    public static TraktSyncResponse ListDeleteItems(TraktList list)
+    public static TraktActivity GetCommunityActivity(List<ActivityType> types, List<ActivityAction> actions)
     {
-      string response = Transmit(TraktURIs.ListItemsDelete, list.ToJSON());
-      return response.FromJSON<TraktSyncResponse>();
+      return GetCommunityActivity(types, actions, 0, 0);
     }
 
-    #endregion
+    public static TraktActivity GetCommunityActivity(List<ActivityType> types, List<ActivityAction> actions, long start, long end)
+    {
+      //// get comma seperated list of types and actions (if more than one)
+      //string activityTypes = types == null ? "all" : string.Join(",", types.Select(t => t.ToString()).ToArray());
+      //string activityActions = actions == null ? "all" : string.Join(",", actions.Select(a => a.ToString()).ToArray());
 
-    #region Account
+      //string startEnd = (start == 0 || end == 0) ? string.Empty : string.Format("/{0}/{1}", start, end);
 
-    public static TraktResponse CreateAccount(TraktAccount account)
-    {
-      string response = Transmit(TraktURIs.CreateAccount, account.ToJSON());
-      return response.FromJSON<TraktResponse>();
+      //string activity = Transmit(string.Format(TraktURIs.ActivityCommunity, activityTypes, activityActions, startEnd), GetUserAuthentication());
+      //return activity.FromJSON<TraktActivity>();
+      return null;
     }
 
-    public static TraktResponse TestAccount(TraktAccount account)
+    public static TraktActivity GetUserActivity(string username, List<ActivityType> types, List<ActivityAction> actions)
     {
-      string response = Transmit(TraktURIs.TestAccount, account.ToJSON());
-      return response.FromJSON<TraktResponse>();
-    }
+      //// get comma seperated list of types and actions (if more than one)
+      //string activityTypes = string.Join(",", types.Select(t => t.ToString()).ToArray());
+      //string activityActions = string.Join(",", actions.Select(a => a.ToString()).ToArray());
 
-    public static TraktAccountSettings GetAccountSettings()
-    {
-      string response = Transmit(TraktURIs.AccountSettings, GetUserAuthentication());
-      return response.FromJSON<TraktAccountSettings>();
+      //string activity = Transmit(string.Format(TraktURIs.ActivityUser, username, activityTypes, activityActions), GetUserAuthentication());
+      //return activity.FromJSON<TraktActivity>();
+      return null;
     }
 
     #endregion
 
     #region Search
 
+    private static readonly Object searchLock = new Object();
+
     /// <summary>
+    /// //TODO switch over to comma-seperate types in a single search
     /// Search from one or more types, movies, episodes, shows etc...
     /// </summary>
     /// <param name="searchTerm">string to search for</param>
     /// <param name="types">a list of search types</param>
-    /// <param name="maxResults"></param>
     /// <returns>returns results from multiple search types</returns>
-    public static TraktSearchResult Search(string searchTerm, HashSet<SearchType> types, int maxResults)
+    public static IEnumerable<TraktSearchResult> Search(string searchTerm, HashSet<SearchType> types, int maxResults)
     {
       // collect all the results from each type in this list
-      TraktSearchResult results = new TraktSearchResult();
+      List<TraktSearchResult> results = new List<TraktSearchResult>();
 
       // run all search types in parallel
       List<Thread> threads = new List<Thread>();
